/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;namespace PluginIdea.VolumeLight{public class VLGeometry : MonoBehaviour{void Start(){if (!vlMono)                DestroyImmediate(gameObject);}void OnDestroy(){if (currentMaterial){DestroyImmediate(currentMaterial);currentMaterial = null;}}public void Initialize(VolumetricLightMono master){var hideFlags = GlobalConfig.ProceduralObjectsHideFlags;vlMono = master;transform.SetParent(master.transform, false);meshRenderer = gameObject.GetOrAddComponent<MeshRenderer>();meshRenderer.hideFlags = hideFlags;meshRenderer.shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.Off;meshRenderer.receiveShadows = false;meshRenderer.lightProbeUsage = UnityEngine.Rendering.LightProbeUsage.Off;if (GlobalConfig.Instance.actualRenderingMode != RenderingMode.GPUInstancing){currentMaterial = MaterialMgr.NewMaterial(gpuInstanced:false);ApplyMaterial();}if (SortingLayer.IsValid(vlMono.sortingLayerID))                sortingLayerID = vlMono.sortingLayerID;else                Debug.LogError(string.Format("Beam '{0}' has an invalid sortingLayerID ({1}). Please fix it by setting a valid layer.", Utils.GetPath(vlMono.transform), vlMono.sortingLayerID));sortingOrder = vlMono.sortingOrder;meshFilter = gameObject.GetOrAddComponent<MeshFilter>();meshFilter.hideFlags = hideFlags;gameObject.hideFlags = hideFlags;}public void RegenerateMesh(){if (GlobalConfig.Instance.geoOverrideLayer)                gameObject.layer = GlobalConfig.Instance.geoLayerID;else                gameObject.layer = vlMono.gameObject.layer;gameObject.tag = GlobalConfig.Instance.geoTag;currentMeshType = vlMono.geomMeshType;coneMesh = MeshGenerator.Get();meshFilter.sharedMesh = coneMesh;UpdateMaterialAndBounds();}void ComputeLocalMatrix(){var maxRadius = Mathf.Max(vlMono.coneRadiusStart, vlMono.coneRadiusEnd);transform.localScale = new Vector3(maxRadius, maxRadius, vlMono.fadeEnd);}bool isNoiseEnabled{get{return vlMono.noiseEnabled && vlMono.noiseIntensity > 0f && Noise3D.isSupported;}}bool isClippingPlaneEnabled{get{return m_ClippingPlaneWS.normal.sqrMagnitude > 0;}}bool isUseDepthBlend{get{return  vlMono.depthBlendDistance > 0f;}}void SetMaterialProp(string name, float value){if (currentMaterial)                currentMaterial.SetFloat(name, value);else                MaterialMgr.materialPropertyBlock.SetFloat(name, value);}void SendMaterialClippingPlaneProp(){SetMaterialProp("_ClippingPlaneWS", new Vector4(m_ClippingPlaneWS.normal.x, m_ClippingPlaneWS.normal.y, m_ClippingPlaneWS.normal.z, m_ClippingPlaneWS.distance));}void SetMaterialProp(string name, Vector4 value){if (currentMaterial)                currentMaterial.SetVector(name, value);else                MaterialMgr.materialPropertyBlock.SetVector(name, value);}void SetMaterialProp(string name, Color value){if (currentMaterial)                currentMaterial.SetColor(name, value);else                MaterialMgr.materialPropertyBlock.SetColor(name, value);}void SetMaterialProp(string name, Matrix4x4 value){if (currentMaterial)                currentMaterial.SetMatrix(name, value);else                MaterialMgr.materialPropertyBlock.SetMatrix(name, value);}bool ApplyMaterial(){var colorGradient = MaterialMgr.ColorGradient.Off;if (vlMono.colorMode == ColorMode.Gradient){var precision = Utils.GetFloatPackingPrecision();colorGradient = precision == Utils.FloatPackingPrecision.High ? MaterialMgr.ColorGradient.MatrixHigh : MaterialMgr.ColorGradient.MatrixLow;}var staticProps = new MaterialMgr.StaticProperties{blendingMode = vlMono.blendingMode,                noise3D = isNoiseEnabled ? MaterialMgr.Noise3D.On : MaterialMgr.Noise3D.Off,                depthBlend = isUseDepthBlend ? MaterialMgr.DepthBlend.On : MaterialMgr.DepthBlend.Off,                colorGradient = colorGradient,                clippingPlane = isClippingPlaneEnabled ? MaterialMgr.ClippingPlane.On : MaterialMgr.ClippingPlane.Off};Material mat = null;if (GlobalConfig.Instance.actualRenderingMode != RenderingMode.GPUInstancing){mat = currentMaterial;if (mat)                    staticProps.ApplyToMaterial(mat);}else{mat = MaterialMgr.GetInstancedMaterial(vlMono._INTERNAL_InstancedMaterialGroupID, staticProps);}meshRenderer.material = mat;return mat != null;}public void UpdateMaterialAndBounds(){if (ApplyMaterial() == false){return;}if (isClippingPlaneEnabled && currentMaterial == null){SendMaterialClippingPlaneProp();}float slopeRad = (vlMono.coneAngle * Mathf.Deg2Rad) / 2;SetMaterialProp("_ConeSlopeCosSin", new Vector2(Mathf.Cos(slopeRad), Mathf.Sin(slopeRad)));const float kMinRadius = 0.0001f;var coneRadius = new Vector2(Mathf.Max(vlMono.coneRadiusStart, kMinRadius), Mathf.Max(vlMono.coneRadiusEnd, kMinRadius));SetMaterialProp("_ConeRadius", coneRadius);const float kMinApexOffset = 0.0001f;float nonNullApex = Mathf.Sign(vlMono.coneApexOffsetZ) * Mathf.Max(Mathf.Abs(vlMono.coneApexOffsetZ), kMinApexOffset);SetMaterialProp("_ConeApexOffsetZ", nonNullApex);if (vlMono.colorMode == ColorMode.Flat){SetMaterialProp("_ColorFlat", vlMono.color);}else{var precision = Utils.GetFloatPackingPrecision();colorGridentMatrix = vlMono.colorGradient.SampleInMatrix((int)precision);}SetMaterialProp("_AlphaInside", vlMono.alphaInside);SetMaterialProp("_AlphaOutside", vlMono.alphaOutside);SetMaterialProp("_AttenuationLerpLinearQuad", vlMono.attenuationLerpLinearQuad);SetMaterialProp("_DistanceFadeStart", vlMono.fadeStart);SetMaterialProp("_DistanceFadeEnd", vlMono.fadeEnd);SetMaterialProp("_DistanceCamClipping", vlMono.cameraClippingDistance);SetMaterialProp("_FresnelPow", Mathf.Max(0.001f, vlMono.fresnelPow));SetMaterialProp("_GlareBehind", vlMono.glareBehind);SetMaterialProp("_GlareFrontal", vlMono.glareFrontal);SetMaterialProp("_DrawCap", vlMono.geomCap ? 1 : 0);if (isUseDepthBlend){SetMaterialProp("_DepthBlendDistance", vlMono.depthBlendDistance);}if (isNoiseEnabled){Noise3D.LoadIfNeeded();SetMaterialProp("_NoiseLocal", new Vector4(vlMono.noiseVelocityLocal.x, vlMono.noiseVelocityLocal.y, vlMono.noiseVelocityLocal.z, vlMono.noiseScaleLocal));SetMaterialProp("_NoiseParam", new Vector3(vlMono.noiseIntensity, vlMono.noiseVelocityUseGlobal ? 1f : 0f, vlMono.noiseScaleUseGlobal ? 1f : 0f));}if(currentMaterial == null)                meshRenderer.SetPropertyBlock(MaterialMgr.materialPropertyBlock);ComputeLocalMatrix();}Plane m_ClippingPlaneWS;public void SetClippingPlane(Plane planeWS){m_ClippingPlaneWS = planeWS;if (currentMaterial){currentMaterial.EnableKeyword("VLB_CLIPPING_PLANE");SendMaterialClippingPlaneProp();}else                UpdateMaterialAndBounds();}public void SetClippingPlaneOff(){m_ClippingPlaneWS = new Plane();if (currentMaterial)                currentMaterial.DisableKeyword("VLB_CLIPPING_PLANE");else                UpdateMaterialAndBounds();}void OnWillRenderObject(){{var cam = Camera.current;if (cam != null)                    UpdateCameraRelatedProperties(cam);}}void UpdateCameraRelatedProperties(Camera cam){if (cam && vlMono){if (currentMaterial == null)                    meshRenderer.GetPropertyBlock(MaterialMgr.materialPropertyBlock);var camPosOS = vlMono.transform.InverseTransformPoint(cam.transform.position);var camForwardVectorOSN = transform.InverseTransformDirection(cam.transform.forward).normalized;float camIsInsideBeamFactor = cam.orthographic ? -1f : vlMono.GetInsideBeamFactorFromObjectSpacePos(camPosOS);SetMaterialProp("_CameraParams", new Vector4(camForwardVectorOSN.x, camForwardVectorOSN.y, camForwardVectorOSN.z, camIsInsideBeamFactor));if (vlMono.colorMode == ColorMode.Gradient){SetMaterialProp("_ColorGradientMatrix", colorGridentMatrix);}if (currentMaterial == null)                    meshRenderer.SetPropertyBlock(MaterialMgr.materialPropertyBlock);if (vlMono.depthBlendDistance > 0f)                    cam.depthTextureMode |= DepthTextureMode.Depth;}}VolumetricLightMono vlMono = null;Matrix4x4 colorGridentMatrix;int currentMeshType = MeshType.Shared;Material currentMaterial = null;public MeshRenderer meshRenderer{get;private set;}public MeshFilter meshFilter{get;private set;}public Mesh coneMesh{get;private set;}public bool visible{get{return meshRenderer.enabled;}set{meshRenderer.enabled = value;}}public int sortingLayerID{get{return meshRenderer.sortingLayerID;}set{meshRenderer.sortingLayerID = value;}}public int sortingOrder{get{return meshRenderer.sortingOrder;}set{meshRenderer.sortingOrder = value;}}}}